/**
* Created by zhangyh on 2015/1/4.
*/
requirejs.config({
    baseUrl: isLocal ? '../../scripts/lib':''+baseurl+'OAPlus/scripts/lib',//@for cordova
    paths: {
        "zepto": "zepto/zepto.min",
        "underscore": "underscore/underscore",
        "json2": "jsons/json2",
        "mobilekit": "mobilekit/mobileKit.min",
        "domReady": "requirejs/domReady",
        "text": "requirejs/text",
        "css": "requirejs/css",
        "swiper":"swiper/swiper.min",
        'app': '../app',
        'datetime': 'mobilescroll.datetime/js/mobiscroll.custom-2.16.1.min',
        'area':'mobiscroll.custom-area/js/mobiscroll.custom-area.min',
        'calendar': 'calendar/calendar',
        "echarts":'echarts/echarts.simple.min',
        "base64": "base64/base64.min",
        "cookie": "cookie/zepto.cookie",
        "iscroll": "iscroll/iscroll-probe"
    },
    shim: {
		"cookie":{
            deps:["zepto"]
        },
		"base64":{
            deps:["zepto"]
        },
        "zepto": {
            //deps: ["underscore"],
            exports: "zepto"
        },
        "mobilekit": {
            deps: ["zepto"],
            exports: "mobilekit"
        },
        "datetime":{
            deps: ["zepto","css!../../styles/css/mobiscroll.custom-2.16.1.min.css"],
            exports: "datetime"
        },
        "swiper":{
            deps: ["css!../../styles/css/swiper.css"],
            exports:"swiper"
        },
        "area":{
            deps: ["zepto","css!../../styles/css/mobiscroll.custom-2.16.1.min.css"],
            exports:"area"
        },
        "calendar":{
            deps: ["zepto","css!../../styles/css/calendar.css"],
            exports:"calendar"
        },
        "echarts":{
            deps:[''],
            exports:"echarts"
        }
    }
    ,
    map: {

    },
    waitSeconds: 30,
    deps:["app/getSkin","app/hideBar"],//增加皮肤相关的默认运行脚本
    //urlArgs: "v=" + (new Date()).getTime(),
    enforceDefine: false
});