var isWrite=false,
	writeTimer=null,
	clientW=document.documentElement.clientWidth || document.body.clientWidth,
	clientH=document.documentElement.clientHeight || document.body.clientHeight;
window.onload=function(){
	

;(function() {
	var apinamespace = 'jSignature';
	var KickTimerClass = function(time, callback) {
		var timer
		this.kick = function() {
			clearTimeout(timer)
			timer = setTimeout(
				callback
				, time
			)
		}
		this.clear = function() {
			clearTimeout(timer)
		}
		return this
	}
	var PubSubClass = function(context){
		'use strict'
		/*  @preserve
		 -----------------------------------------------------------------------------------------------
		 JavaScript PubSub library
		 2012 (c) Willow Systems Corp (www.willow-systems.com)
		 based on Peter Higgins (dante@dojotoolkit.org)
		 Loosely based on Dojo publish/subscribe API, limited in scope. Rewritten blindly.
		 Original is (c) Dojo Foundation 2004-2010. Released under either AFL or new BSD, see:
		 http://dojofoundation.org/license for more information.
		 -----------------------------------------------------------------------------------------------
		 */
		this.topics = {}
		// here we choose what will be "this" for the called events.
		// if context is defined, it's context. Else, 'this' is this instance of PubSub
		this.context = context ? context : this
		/**
		 * Allows caller to emit an event and pass arguments to event listeners.
		 * @public
		 * @function
		 * @param topic {String} Name of the channel on which to voice this event
		 * @param **arguments Any number of arguments you want to pass to the listeners of this event.
		 */
		this.publish = function(topic, arg1, arg2, etc) {
			'use strict'
			if (this.topics[topic]) {
				var currentTopic = this.topics[topic]
					, args = Array.prototype.slice.call(arguments, 1)
					, toremove = []
					, fn
					, i, l
					, pair
					try{
						for (i = 0, l = currentTopic.length; i < l; i++) {
							pair = currentTopic[i] // this is a [function, once_flag] array
							fn = pair[0]
							if (pair[1] /* 'run once' flag set */){
								pair[0] = function(){}
								toremove.push(i)
							}
							fn.apply(this.context, args)
						}
						for (i = 0, l = toremove.length; i < l; i++) {
							currentTopic.splice(toremove[i], 1)
						}
					}catch(e){};
				
			}
		}
		/**
		 * Allows listener code to subscribe to channel and be called when data is available
		 * @public
		 * @function
		 * @param topic {String} Name of the channel on which to voice this event
		 * @param callback {Function} Executable (function pointer) that will be ran when event is voiced on this channel.
		 * @param once {Boolean} (optional. False by default) Flag indicating if the function is to be triggered only once.
		 * @returns {Object} A token object that cen be used for unsubscribing.
		 */
		this.subscribe = function(topic, callback, once) {
			'use strict'
			if (!this.topics[topic]) {
				this.topics[topic] = [[callback, once]];
			} else {
				this.topics[topic].push([callback,once]);
			}
			return {
				"topic": topic,
				"callback": callback
			};
		};
		/**
		 * Allows listener code to unsubscribe from a channel
		 * @public
		 * @function
		 * @param token {Object} A token object that was returned by `subscribe` method
		 */
		this.unsubscribe = function(token) {
			if (this.topics[token.topic]) {
				var currentTopic = this.topics[token.topic]

				for (var i = 0, l = currentTopic.length; i < l; i++) {
					try{
						if (currentTopic[i][0] === token.callback) {
							currentTopic.splice(i, 1)
						}
					}catch(e){

					};
					
				}
			}
		}
	}
	function getColors($e){
		var tmp
			, undef
			, frontcolor = $e.css('color')
			, backcolor
			, e = $e[0]

		var toOfDOM = false
		while(e && !backcolor && !toOfDOM){
			try{
				tmp = $(e).css('background-color')
			} catch (ex) {
				tmp = 'transparent'
			}
			if (tmp !== 'transparent' && tmp !== 'rgba(0, 0, 0, 0)'){
				backcolor = tmp
			}
			toOfDOM = e.body
			e = e.parentNode
		}

		var rgbaregex = /rgb[a]*\((\d+),\s*(\d+),\s*(\d+)/ // modern browsers
			, hexregex = /#([AaBbCcDdEeFf\d]{2})([AaBbCcDdEeFf\d]{2})([AaBbCcDdEeFf\d]{2})/ // IE 8 and less.
			, frontcolorcomponents
		tmp = undef
		tmp = frontcolor.match(rgbaregex)
		if (tmp){
			frontcolorcomponents = {'r':parseInt(tmp[1],10),'g':parseInt(tmp[2],10),'b':parseInt(tmp[3],10)}
		} else {
			tmp = frontcolor.match(hexregex)
			if (tmp) {
				frontcolorcomponents = {'r':parseInt(tmp[1],16),'g':parseInt(tmp[2],16),'b':parseInt(tmp[3],16)}
			}
		}
		var backcolorcomponents
		if(!backcolor){
			if(frontcolorcomponents){
				if (Math.max.apply(null, [frontcolorcomponents.r, frontcolorcomponents.g, frontcolorcomponents.b]) > 127){
					backcolorcomponents = {'r':0,'g':0,'b':0}
				} else {
					backcolorcomponents = {'r':255,'g':255,'b':255}
				}
			} else {
				backcolorcomponents = {'r':255,'g':255,'b':255}
			}
		} else {
			tmp = undef
			tmp = backcolor.match(rgbaregex)
			if (tmp){
				backcolorcomponents = {'r':parseInt(tmp[1],10),'g':parseInt(tmp[2],10),'b':parseInt(tmp[3],10)}
			} else {
				tmp = backcolor.match(hexregex)
				if (tmp) {
					backcolorcomponents = {'r':parseInt(tmp[1],16),'g':parseInt(tmp[2],16),'b':parseInt(tmp[3],16)}
				}
			}
		}
		var toRGBfn = function(o){return 'rgb(' + [o.r, o.g, o.b].join(', ') + ')'}
			, decorcolorcomponents
			, frontcolorbrightness
			, adjusted

		if (frontcolorcomponents && backcolorcomponents){
			var backcolorbrightness = Math.max.apply(null, [frontcolorcomponents.r, frontcolorcomponents.g, frontcolorcomponents.b])

			frontcolorbrightness = Math.max.apply(null, [backcolorcomponents.r, backcolorcomponents.g, backcolorcomponents.b])
			adjusted = Math.round(frontcolorbrightness + (-1 * (frontcolorbrightness - backcolorbrightness) * 0.75)) // "dimming" the difference between pen and back.
			decorcolorcomponents = {'r':adjusted,'g':adjusted,'b':adjusted} // always shade of gray
		} else if (frontcolorcomponents) {
			frontcolorbrightness = Math.max.apply(null, [frontcolorcomponents.r, frontcolorcomponents.g, frontcolorcomponents.b])
			var polarity = +1
			if (frontcolorbrightness > 127){
				polarity = -1
			}
			adjusted = Math.round(frontcolorbrightness + (polarity * 96)) // "dimming" the pen's color by 75% to get decor color.
			decorcolorcomponents = {'r':adjusted,'g':adjusted,'b':adjusted} // always shade of gray
		} else {
			decorcolorcomponents = {'r':191,'g':191,'b':191} // always shade of gray
		}

		return {
			'color': frontcolor
			, 'background-color': backcolorcomponents? toRGBfn(backcolorcomponents) : backcolor
			, 'decor-color': toRGBfn(decorcolorcomponents)
		}
	}

	function Vector(x,y){
		this.x = x
		this.y = y
		this.reverse = function(){
			return new this.constructor(
				this.x * -1
				, this.y * -1
			)
		}
		this._length = null
		this.getLength = function(){
			if (!this._length){
				this._length = Math.sqrt( Math.pow(this.x, 2) + Math.pow(this.y, 2) )
			}
			return this._length
		}

		var polarity = function (e){
			return Math.round(e / Math.abs(e))
		}
		this.resizeTo = function(length){
			// proportionally changes x,y such that the hypotenuse (vector length) is = new length
			if (this.x === 0 && this.y === 0){
				this._length = 0
			} else if (this.x === 0){
				this._length = length
				this.y = length * polarity(this.y)
			} else if(this.y === 0){
				this._length = length
				this.x = length * polarity(this.x)
			} else {
				var proportion = Math.abs(this.y / this.x)
					, x = Math.sqrt(Math.pow(length, 2) / (1 + Math.pow(proportion, 2)))
					, y = proportion * x
				this._length = length
				this.x = x * polarity(this.x)
				this.y = y * polarity(this.y)
			}
			return this
		}

		/**
		 * Calculates the angle between 'this' vector and another.
		 * @public
		 * @function
		 * @returns {Number} The angle between the two vectors as measured in PI.
		 */
		this.angleTo = function(vectorB) {
			var divisor = this.getLength() * vectorB.getLength()
			if (divisor === 0) {
				return 0
			} else {
				// JavaScript floating point math is screwed up.
				// because of it, the core of the formula can, on occasion, have values
				// over 1.0 and below -1.0.
				return Math.acos(
						Math.min(
							Math.max(
								( this.x * vectorB.x + this.y * vectorB.y ) / divisor
								, -1.0
							)
							, 1.0
						)
					) / Math.PI
			}
		}
	}

	function Point(x,y){
		this.x = x
		this.y = y

		this.getVectorToCoordinates = function (x, y) {
			return new Vector(x - this.x, y - this.y)
		}
		this.getVectorFromCoordinates = function (x, y) {
			return this.getVectorToCoordinates(x, y).reverse()
		}
		this.getVectorToPoint = function (point) {
			return new Vector(point.x - this.x, point.y - this.y)
		}
		this.getVectorFromPoint = function (point) {
			return this.getVectorToPoint(point).reverse()
		}
	}
	function DataEngine(storageObject, context, startStrokeFn, addToStrokeFn, endStrokeFn){
		this.data = storageObject // we expect this to be an instance of Array
		this.context = context

		if (storageObject.length){
			// we have data to render
			var numofstrokes = storageObject.length
				, stroke
				, numofpoints

			for (var i = 0; i < numofstrokes; i++){
				stroke = storageObject[i]
				numofpoints = stroke.x.length
				startStrokeFn.call(context, stroke)
				for(var j = 1; j < numofpoints; j++){
					addToStrokeFn.call(context, stroke, j)
				}//
				endStrokeFn.call(context, stroke)
			}
		}

		this.changed = function(){}

		this.startStrokeFn = startStrokeFn
		this.addToStrokeFn = addToStrokeFn
		this.endStrokeFn = endStrokeFn

		this.inStroke = false

		this._lastPoint = null
		this._stroke = null
		this.startStroke = function(point){
			if(point && typeof(point.x) == "number" && typeof(point.y) == "number"){
				this._stroke = {'x':[point.x], 'y':[point.y]}
				this.data.push(this._stroke)
				this._lastPoint = point
				this.inStroke = true
				// 'this' does not work same inside setTimeout(
				var stroke = this._stroke
					, fn = this.startStrokeFn
					, context = this.context
				setTimeout(
					// some IE's don't support passing args per setTimeout API. Have to create closure every time instead.
					function() {fn.call(context, stroke)}
					, 3
				)
				//console.log(point);
				winX=point.x;
				winY=point.y;
				return point
			} else {
				return null
			}
		}
		// that "5" at the very end of this if is important to explain.
		// we do NOT render links between two captured points (in the middle of the stroke) if the distance is shorter than that number.
		// not only do we NOT render it, we also do NOT capture (add) these intermediate points to storage.
		// when clustering of these is too tight, it produces noise on the line, which, because of smoothing, makes lines too curvy.
		// maybe, later, we can expose this as a configurable setting of some sort.
		this.addToStroke = function(point){
			if (this.inStroke &&
				typeof(point.x) === "number" &&
				typeof(point.y) === "number" &&
					// calculates absolute shift in diagonal pixels away from original point
				(Math.abs(point.x - this._lastPoint.x) + Math.abs(point.y - this._lastPoint.y)) > 4
			){
				var positionInStroke = this._stroke.x.length
				this._stroke.x.push(point.x)
				this._stroke.y.push(point.y)
				this._lastPoint = point

				var stroke = this._stroke
					, fn = this.addToStrokeFn
					, context = this.context
				setTimeout(
					// some IE's don't support passing args per setTimeout API. Have to create closure every time instead.
					function() {fn.call(context, stroke, positionInStroke)}
					, 3
				)
				return point
			} else {
				return null
			}
		}
		this.endStroke = function(){
			var c = this.inStroke
			this.inStroke = false
			this._lastPoint = null
			if (c){
				var stroke = this._stroke
					, fn = this.endStrokeFn // 'this' does not work same inside setTimeout(
					, context = this.context
					, changedfn = this.changed
				setTimeout(
					// some IE's don't support passing args per setTimeout API. Have to create closure every time instead.
					function(){
						fn.call(context, stroke)
						changedfn.call(context)
					}
					, 3
				)
				return true
			} else {
				return null
			}
		}
	}//2
	var basicDot = function(ctx, x, y, size){
			var fillStyle = ctx.fillStyle
			ctx.fillStyle = ctx.strokeStyle
			ctx.fillRect(x + size / -2 , y + size / -2, size, size)
			ctx.fillStyle = fillStyle
		}
		, basicLine = function(ctx, startx, starty, endx, endy){
			ctx.beginPath()
			ctx.moveTo(startx, starty)
			ctx.lineTo(endx, endy)
			ctx.stroke()
		}
		, basicCurve = function(ctx, startx, starty, endx, endy, cp1x, cp1y, cp2x, cp2y){
			ctx.beginPath()
			ctx.moveTo(startx, starty)
			ctx.bezierCurveTo(cp1x, cp1y, cp2x, cp2y, endx, endy)
			ctx.stroke()
		}
		, strokeStartCallback = function(stroke) {
			// this = jSignatureClass instance
			basicDot(this.canvasContext, stroke.x[0], stroke.y[0], this.settings.lineWidth)
		}
		, strokeAddCallback = function(stroke, positionInStroke){
			var Cpoint = new Point(stroke.x[positionInStroke-1], stroke.y[positionInStroke-1])
				, Dpoint = new Point(stroke.x[positionInStroke], stroke.y[positionInStroke])
				, CDvector = Cpoint.getVectorToPoint(Dpoint)
			if(positionInStroke > 1) {
				var Bpoint = new Point(stroke.x[positionInStroke-2], stroke.y[positionInStroke-2])
					, BCvector = Bpoint.getVectorToPoint(Cpoint)
					, ABvector
				if(BCvector.getLength() > this.lineCurveThreshold){
					if(positionInStroke > 2) {
						ABvector = (new Point(stroke.x[positionInStroke-3], stroke.y[positionInStroke-3])).getVectorToPoint(Bpoint)
					} else {
						ABvector = new Vector(0,0)
					}
					var minlenfraction = 0.05
						, maxlen = BCvector.getLength() * 0.35
						, ABCangle = BCvector.angleTo(ABvector.reverse())
						, BCDangle = CDvector.angleTo(BCvector.reverse())
						, BCP1vector = new Vector(ABvector.x + BCvector.x, ABvector.y + BCvector.y).resizeTo(
							Math.max(minlenfraction, ABCangle) * maxlen
						)
						, CCP2vector = (new Vector(BCvector.x + CDvector.x, BCvector.y + CDvector.y)).reverse().resizeTo(
							Math.max(minlenfraction, BCDangle) * maxlen
						)

					basicCurve(
						this.canvasContext
						, Bpoint.x
						, Bpoint.y
						, Cpoint.x
						, Cpoint.y
						, Bpoint.x + BCP1vector.x
						, Bpoint.y + BCP1vector.y
						, Cpoint.x + CCP2vector.x
						, Cpoint.y + CCP2vector.y
					)
				}
			}
			if(CDvector.getLength() <= this.lineCurveThreshold){
				basicLine(
					this.canvasContext
					, Cpoint.x
					, Cpoint.y
					, Dpoint.x
					, Dpoint.y
				)
			}
		}
		, strokeEndCallback = function(stroke){
			var positionInStroke = stroke.x.length - 1

			if (positionInStroke > 0){
				var Cpoint = new Point(stroke.x[positionInStroke], stroke.y[positionInStroke])
					, Bpoint = new Point(stroke.x[positionInStroke-1], stroke.y[positionInStroke-1])
					, BCvector = Bpoint.getVectorToPoint(Cpoint)
					, ABvector
				if (BCvector.getLength() > this.lineCurveThreshold){
					if (positionInStroke > 1){
						ABvector = (new Point(stroke.x[positionInStroke-2], stroke.y[positionInStroke-2])).getVectorToPoint(Bpoint)
						var BCP1vector = new Vector(ABvector.x + BCvector.x, ABvector.y + BCvector.y).resizeTo(BCvector.getLength() / 2)
						basicCurve(
							this.canvasContext
							, Bpoint.x
							, Bpoint.y
							, Cpoint.x
							, Cpoint.y
							, Bpoint.x + BCP1vector.x
							, Bpoint.y + BCP1vector.y
							, Cpoint.x
							, Cpoint.y
						)
					} else {
						basicLine(
							this.canvasContext
							, Bpoint.x
							, Bpoint.y
							, Cpoint.x
							, Cpoint.y
						)
					}
				}
			}
		}
	function conditionallyLinkCanvasResizeToWindowResize(jSignatureInstance, settingsWidth, apinamespace, globalEvents){
		'use strict'
		if ( settingsWidth === 'ratio' || settingsWidth.split('')[settingsWidth.length - 1] === '%' ) {

			this.eventTokens[apinamespace + '.parentresized'] = globalEvents.subscribe(
				apinamespace + '.parentresized'
				, (function(eventTokens, $parent, originalParentWidth, sizeRatio){
					'use strict'
					return function(){
						'use strict'
						var w = $parent.width()
						if (w !== originalParentWidth) {
							for (var key in eventTokens){
								if (eventTokens.hasOwnProperty(key)) {
									globalEvents.unsubscribe(eventTokens[key])
									delete eventTokens[key]
								}
							}

							var settings = jSignatureInstance.settings
							jSignatureInstance.$parent.children().remove()
							for (var key in jSignatureInstance){
								if (jSignatureInstance.hasOwnProperty(key)) {
									delete jSignatureInstance[key]
								}
							}
							settings.data = (function(data, scale){
								var newData = []
								var o, i, l, j, m, stroke
								for ( i = 0, l = data.length; i < l; i++) {
									stroke = data[i]

									o = {'x':[],'y':[]}

									for ( j = 0, m = stroke.x.length; j < m; j++) {
										o.x.push(stroke.x[j] * scale)
										o.y.push(stroke.y[j] * scale)
									}

									newData.push(o)
								}
								return newData
							})(
								settings.data
								, w * 1.0 / originalParentWidth
							)

							$parent[apinamespace](settings)
						}
					}
				})(
					this.eventTokens
					, this.$parent
					, this.$parent.width()
					, this.canvas.width * 1.0 / this.canvas.height
				)
			)
		}
	}


	function jSignatureClass(parent, options, instanceExtensions) {
		var _this=this;
		var $parent = this.$parent = $(parent)
			, eventTokens = this.eventTokens = {}
			, events = this.events = new PubSubClass(this)
			, globalEvents = $.fn[apinamespace]('globalEvents')
			, settings = {
				'width' : 'ratio'
				,'height' : 'ratio'
				,'sizeRatio': 4 // only used when height = 'ratio'
				,'color' : '#000'
				,'background-color': '#ccc'
				,'decor-color': '#eee'
				,'lineWidth' : 0
				,'minFatFingerCompensation' : -10
				,'showUndoButton': false
				,'data': []
			}

		$.extend(settings, getColors($parent))
		if (options) {
			$.extend(settings, options)
		}
		this.settings = settings

		for (var extensionName in instanceExtensions){
			if (instanceExtensions.hasOwnProperty(extensionName)) {
				instanceExtensions[extensionName].call(this, extensionName)
			}
		}

		this.events.publish(apinamespace+'.initializing')
		this.$controlbarUpper = (function(){
			var controlbarstyle = 'padding:0 !important;margin:0 !important;'+
				'width: 100% !important; height: 0 !important;'+
				'margin-top:-1em !important;margin-bottom:1em !important;'
		})();

		this.isCanvasEmulator = false // will be flipped by initializer when needed.
		var canvas = this.canvas = this.initializeCanvas(settings)
			, $canvas = $(canvas)
		this.$controlbarLower = (function(){
			var controlbarstyle = 'padding:0 !important;margin:0 !important;'+
				'width: 100% !important; height: 100% !important;'+
				'margin-top:-1.5em !important;margin-bottom:1.5em !important;'
		})();

		this.canvasContext = canvas.getContext("2d")
		$canvas.data(apinamespace + '.this', this)
		settings.lineWidth = (function(defaultLineWidth, canvasWidth){//画笔粗细
			if (!defaultLineWidth){
				return Math.max(
					Math.round(canvasWidth / 400)
					, 2
				)
			} else {
				return defaultLineWidth
			}
		})(settings.lineWidth, canvas.width);

		this.lineCurveThreshold = settings.lineWidth * 3
		if(settings.cssclass && $.trim(settings.cssclass) != "") {
			$canvas.addClass(settings.cssclass)
		}
		this.fatFingerCompensation = 0

		var movementHandlers = (function(jSignatureInstance) {
				var shiftX
					, shiftY
					, setStartValues = function(){
						var tos = $(jSignatureInstance.canvas).offset()
						shiftX = tos.left * -1
						shiftY = tos.top * -1
					}
					, getPointFromEvent = function(e) {
						var firstEvent = (e.changedTouches && e.changedTouches.length > 0 ? e.changedTouches[0] : e)
						return new Point(
							Math.round(firstEvent.pageX + shiftX)
							, Math.round(firstEvent.pageY + shiftY) + jSignatureInstance.fatFingerCompensation
						)
					}
					, timer = new KickTimerClass(
						750
						, function() { jSignatureInstance.dataEngine.endStroke();}
					)

				this.drawEndHandler = function(e) {
					try { e.preventDefault() } catch (ex) {}
					timer.clear()
					jSignatureInstance.dataEngine.endStroke();
					isWrite=false;
					if($('#canvasWrap').hasClass('writeActive')){
						writeTimer=setTimeout(function(){
							if(!isWrite){
								jsig.getImg();
								$('#imgWrap .line').remove();
								jsig.drawLine();
							}
						},1000)
					}

				}
				this.drawStartHandler = function(e) {
					
					clearTimeout(writeTimer);
					isWrite=true;
					e.preventDefault()
					setStartValues()
					jSignatureInstance.dataEngine.startStroke( getPointFromEvent(e) )
					timer.kick()
				}
				this.drawMoveHandler = function(e) {
					e.preventDefault()
					if (!jSignatureInstance.dataEngine.inStroke){
						return
					}
					jSignatureInstance.dataEngine.addToStroke( getPointFromEvent(e) )
					timer.kick()
				}
				return this
			}).call( {}, this )
			;(function(drawEndHandler, drawStartHandler, drawMoveHandler) {
			var canvas = this.canvas
				, $canvas = $(canvas)
				, undef
			if (this.isCanvasEmulator){console.log(1);
				$canvas.bind('mousemove.'+apinamespace, drawMoveHandler)
				$canvas.bind('mouseup.'+apinamespace, drawEndHandler)
				$canvas.bind('mousedown.'+apinamespace, drawStartHandler)
			} else {
				canvas.ontouchstart = function(e) {
					canvas.onmousedown = undef
					canvas.onmouseup = undef
					canvas.onmousemove = undef

					this.fatFingerCompensation = (
					settings.minFatFingerCompensation &&
					settings.lineWidth * -3 > settings.minFatFingerCompensation
					) ? settings.lineWidth * -3 : settings.minFatFingerCompensation

					drawStartHandler(e)
					canvas.ontouchend = drawEndHandler
					canvas.ontouchstart = drawStartHandler
					canvas.ontouchmove = drawMoveHandler
				}
				canvas.onmousedown = function(e) {

					canvas.ontouchstart = undef
					canvas.ontouchend = undef
					canvas.ontouchmove = undef

					drawStartHandler(e)
					console.log(3);
					canvas.onmousedown = drawStartHandler
					canvas.onmouseup = drawEndHandler
					canvas.onmousemove = drawMoveHandler
				}
			}
		}).call(
			this
			, movementHandlers.drawEndHandler
			, movementHandlers.drawStartHandler
			, movementHandlers.drawMoveHandler
		)
		console.log(4);
		/*eventTokens[apinamespace + '.windowmouseup'] = globalEvents.subscribe(
			apinamespace + '.windowmouseup'
			, movementHandlers.drawEndHandler
		)*/

		this.events.publish(apinamespace+'.attachingEventHandlers')
		conditionallyLinkCanvasResizeToWindowResize.call(
			this
			, this
			, settings.width.toString(10)
			, apinamespace, globalEvents
		)
		this.resetCanvas(settings.data)
		this.events.publish(apinamespace+'.initialized')
		
		return this
	}

	jSignatureClass.prototype.resetCanvas = function(data){
		var canvas = this.canvas
			, settings = this.settings
			, ctx = this.canvasContext
			, isCanvasEmulator = this.isCanvasEmulator

			, cw = canvas.width
			, ch = canvas.height

		// preparing colors, drawing area

		ctx.clearRect(0, 0, cw + 30, ch + 30)

		ctx.shadowColor = ctx.fillStyle = settings['background-color']
		if (isCanvasEmulator){
			// FLashCanvas fills with Black by default, covering up the parent div's background
			// hence we refill
			ctx.fillRect(0,0,cw + 30, ch + 30)
		}

		ctx.lineWidth = Math.ceil(parseInt(settings.lineWidth, 10))
		ctx.lineCap = ctx.lineJoin = "round"


		// setting up new dataEngine

		if (!data) { data = [] }

		var dataEngine = this.dataEngine = new DataEngine(
			data
			, this
			, strokeStartCallback
			, strokeAddCallback
			, strokeEndCallback
		)

		settings.data = data  // onwindowresize handler uses it, i think.
		$(canvas).data(apinamespace+'.data', data)
			.data(apinamespace+'.settings', settings)

		// we fire "change" event on every change in data.
		// setting this up:
		dataEngine.changed = (function(target, events, apinamespace) {
			'use strict'
			return function() {
				events.publish(apinamespace+'.change')
				target.trigger('change')
			}
		})(this.$parent, this.events, apinamespace)
		// let's trigger change on all data reloads
		dataEngine.changed()

		// import filters will be passing this back as indication of "we rendered"
		return true
	}//1

	function initializeCanvasEmulator(canvas){
		if (canvas.getContext){
			return false
		} else {
			// for cases when jSignature, FlashCanvas is inserted
			// from one window into another (child iframe)
			// 'window' and 'FlashCanvas' may be stuck behind
			// in that other parent window.
			// we need to find it
			var window = canvas.ownerDocument.parentWindow
			var FC = window.FlashCanvas ?
				canvas.ownerDocument.parentWindow.FlashCanvas :
				(
					typeof FlashCanvas === "undefined" ?
						undefined :
						FlashCanvas
				)

			if (FC) {
				canvas = FC.initElement(canvas)

				var zoom = 1
				// FlashCanvas uses flash which has this annoying habit of NOT scaling with page zoom.
				// It matches pixel-to-pixel to screen instead.
				// Since we are targeting ONLY IE 7, 8 with FlashCanvas, we will test the zoom only the IE8, IE7 way
				if (window && window.screen && window.screen.deviceXDPI && window.screen.logicalXDPI){
					zoom = window.screen.deviceXDPI * 1.0 / window.screen.logicalXDPI
				}
				if (zoom !== 1){
					try {
						// We effectively abuse the brokenness of FlashCanvas and force the flash rendering surface to
						// occupy larger pixel dimensions than the wrapping, scaled up DIV and Canvas elems.
						$(canvas).children('object').get(0).resize(Math.ceil(canvas.width * zoom), Math.ceil(canvas.height * zoom))
						// And by applying "scale" transformation we can talk "browser pixels" to FlashCanvas
						// and have it translate the "browser pixels" to "screen pixels"
						canvas.getContext('2d').scale(zoom, zoom)
						// Note to self: don't reuse Canvas element. Repeated "scale" are cumulative.
					} catch (ex) {}
				};
				return true
			} else {
				throw new Error("Canvas element does not support 2d context. jSignature cannot proceed.")
			}
		}

	}

	jSignatureClass.prototype.initializeCanvas = function(settings) {
		// ===========
		
		var canvas = document.createElement('canvas')
			, $canvas = $(canvas)

		// We cannot work with circular dependency
		if (settings.width === settings.height && settings.height === 'ratio') {
			settings.width = '100%'
		}

		$canvas.css(
			'margin'
			, 0
		).css(
			'padding'
			, 0
		).css(
			'border'
			, 'none'
		).css(
			'height'
			, settings.height === 'ratio' || !settings.height ? 1 : settings.height.toString(10)
		).css(
			'width'
			, settings.width === 'ratio' || !settings.width ? 1 : settings.width.toString(10)
		)
		$canvas.appendTo(this.$parent);
		
		
		// we could not do this until canvas is rendered (appended to DOM)
		if (settings.height === 'ratio') {//设置canvas高度
			if($('#canvasWrap').hasClass('writeActive')){
				$canvas.css(
					'height'
					, 300
				)
			}else{
				$canvas.css(
					'height'
					, Math.round( clientH -100)
				)
			}


		} else if (settings.width === 'ratio') {
			if($('#canvasWrap').hasClass('writeActive')){
				$canvas.css(
					'width'
					, 300
				)
			}else{
				$canvas.css(
					'width'
					, Math.round( $canvas.height() * settings.sizeRatio )
				)
			}

		}

		$canvas.addClass(apinamespace)

		// canvas's drawing area resolution is independent from canvas's size.
		// pixels are just scaled up or down when internal resolution does not
		// match external size. So...

		canvas.width = $canvas.width()
		canvas.height = $canvas.height()

		// Special case Sizing code

		this.isCanvasEmulator = initializeCanvasEmulator(canvas)

		// End of Sizing Code
		// ===========

		// normally select preventer would be short, but
		// Canvas emulator on IE does NOT provide value for Event. Hence this convoluted line.
		canvas.onselectstart = function(e){if(e && e.preventDefault){e.preventDefault()}; if(e && e.stopPropagation){e.stopPropagation()}; return false;}
		
		
		return canvas
	}


	var GlobalJSignatureObjectInitializer = function(window){

		var globalEvents = new PubSubClass()

		// common "window resized" event listener.
		// jSignature instances will subscribe to this chanel.
		// to resize themselves when needed.
			;(function(globalEvents, apinamespace, $, window){
			'use strict'

			var resizetimer
				, runner = function(){
					globalEvents.publish(
						apinamespace + '.parentresized'
					);
				}

			// jSignature knows how to resize its content when its parent is resized
			// window resize is the only way we can catch resize events though...
			$(window).bind('resize.'+apinamespace, function(){
				if (resizetimer) {
					clearTimeout(resizetimer)
				}
				resizetimer = setTimeout(
					runner
					, 500
				)
			})
				// when mouse exists canvas element and "up"s outside, we cannot catch it with
				// callbacks attached to canvas. This catches it outside.
				.bind('mouseup.'+apinamespace, function(e){
					
					globalEvents.publish(
						apinamespace + '.windowmouseup'
					)
				})

		})(globalEvents, apinamespace, $, window)

		var jSignatureInstanceExtensions = {}

		var exportplugins = {
			'default':function(data){return this.toDataURL()}
			, 'native':function(data){return data}
			, 'image':function(data){
				/*this = canvas elem */
				var imagestring = this.toDataURL()

				if (typeof imagestring === 'string' &&
					imagestring.length > 4 &&
					imagestring.slice(0,5) === 'data:' &&
					imagestring.indexOf(',') !== -1){

					var splitterpos = imagestring.indexOf(',')

					return [
						imagestring.slice(5, splitterpos)
						, imagestring.substr(splitterpos + 1)
					]
				}
				return []
			}
		}

		// will be part of "importplugins"
		function _renderImageOnCanvas( data, formattype, rerendercallable ) {
			'use strict'

			var img = new Image()
			// this = Canvas DOM elem. Not jQuery object. Not Canvas's parent div.
				, c = this

			img.onload = function() {
				var ctx = c.getContext("2d").drawImage(
					img, 0, 0
					, ( img.width < c.width) ? img.width : c.width
					, ( img.height < c.height) ? img.height : c.height
				)
			}

			img.src = 'data:' + formattype + ',' + data
		}

		var importplugins = {
			'native':function(data, formattype, rerendercallable){
				// we expect data as Array of objects of arrays here - whatever 'default' EXPORT plugin spits out.
				// returning Truthy to indicate we are good, all updated.
				rerendercallable( data )
			}
			, 'image': _renderImageOnCanvas
			, 'image/png;base64': _renderImageOnCanvas
			, 'image/jpeg;base64': _renderImageOnCanvas
			, 'image/jpg;base64': _renderImageOnCanvas
		}

		function _clearDrawingArea( data ) {
			this.find('canvas.'+apinamespace)
				.add(this.filter('canvas.'+apinamespace))
				.data(apinamespace+'.this').resetCanvas( data )
			return this
		}

		function _setDrawingData( data, formattype ) {
			var undef
			if (formattype === undef && typeof data === 'string' && data.substr(0,5) === 'data:') {
				formattype = data.slice(5).split(',')[0]
				// 5 chars of "data:" + mimetype len + 1 "," char = all skipped.
				data = data.slice(6 + formattype.length)
				if (formattype === data) return
			}

			var $canvas = this.find('canvas.'+apinamespace).add(this.filter('canvas.'+apinamespace))

			if (!importplugins.hasOwnProperty(formattype)){
				throw new Error(apinamespace + " is unable to find import plugin with for format '"+ String(formattype) +"'")
			} else if ($canvas.length !== 0){
				importplugins[formattype].call(
					$canvas[0]
					, data
					, formattype
					, (function(jSignatureInstance){
						return function(){ return jSignatureInstance.resetCanvas.apply(jSignatureInstance, arguments) }
					})($canvas.data(apinamespace+'.this'))
				)
			}

			return this
		}

		var elementIsOrphan = function(e){
			var topOfDOM = false
			e = e.parentNode
			while (e && !topOfDOM){
				topOfDOM = e.body
				e = e.parentNode
			}
			return !topOfDOM
		}

		//These are exposed as methods under $obj.jSignature('methodname', *args)
		var plugins = {'export':exportplugins, 'import':importplugins, 'instance': jSignatureInstanceExtensions}
			, methods = {
				'init' : function( options ) {
					return this.each( function() {
						if (!elementIsOrphan(this)) {
							new jSignatureClass(this, options, jSignatureInstanceExtensions)
						}
					})
				}
				, 'getSettings' : function() {
					return this.find('canvas.'+apinamespace)
						.add(this.filter('canvas.'+apinamespace))
						.data(apinamespace+'.this').settings
				}
				// around since v1
				, 'clear' : _clearDrawingArea
				// was mistakenly introduced instead of 'clear' in v2
				, 'reset' : _clearDrawingArea
				, 'addPlugin' : function(pluginType, pluginName, callable){
					if (plugins.hasOwnProperty(pluginType)){
						plugins[pluginType][pluginName] = callable
					}
					return this
				}
				, 'listPlugins' : function(pluginType){
					var answer = []
					if (plugins.hasOwnProperty(pluginType)){
						var o = plugins[pluginType]
						for (var k in o){
							if (o.hasOwnProperty(k)){
								answer.push(k)
							}
						}
					}
					return answer
				}
				, 'getData' : function( formattype ) {
					var undef, $canvas=this.find('canvas.'+apinamespace).add(this.filter('canvas.'+apinamespace))
					if (formattype === undef) formattype = 'default'
					if ($canvas.length !== 0 && exportplugins.hasOwnProperty(formattype)){
						return exportplugins[formattype].call(
							$canvas.get(0) // canvas dom elem
							, $canvas.data(apinamespace+'.data') // raw signature data as array of objects of arrays
						)
					}
				}
				// around since v1. Took only one arg - data-url-formatted string with (likely png of) signature image
				, 'importData' : _setDrawingData
				// was mistakenly introduced instead of 'importData' in v2
				, 'setData' : _setDrawingData
				// this is one and same instance for all jSignature.
				, 'globalEvents' : function(){return globalEvents}
				// there will be a separate one for each jSignature instance.
				, 'events' : function() {
					return this.find('canvas.'+apinamespace)
						.add(this.filter('canvas.'+apinamespace))
						.data(apinamespace+'.this').events
				}
			} // end of methods declaration.

		$.fn[apinamespace] = function(method) {
			'use strict'
			if ( !method || typeof method === 'object' ) {
				return methods.init.apply( this, arguments )
			} else if ( typeof method === 'string' && methods[method] ) {
				return methods[method].apply( this, Array.prototype.slice.call( arguments, 1 ))
			} else {
				$.error( 'Method ' +  String(method) + ' does not exist on jQuery.' + apinamespace )
			}
		}

	} // end of GlobalJSignatureObjectInitializer
	GlobalJSignatureObjectInitializer(window)
})();
var script1=document.createElement('script');
	script1.type="text/javascript";
	script1.src="../../../OAPlus/scripts/lib/handwrite/plugins/jSignature.CompressorSVG.js"
	document.body.appendChild(script1);
}
var jsig={
	createDialog:function(id){
		var diaLog=[];
			diaLog.push('<div class="canvasWrap hide" id="canvasWrap" signId="'+id+'">');
			diaLog.push('	<div class="writeCont" id="writeCont">');
			diaLog.push('		<div id="imgWrap" contenteditable=true class="imgWrap"></div>');
			diaLog.push('	</div>');
			diaLog.push('	<div class="signature" id="signature"></div>');
			diaLog.push('	<span class="tabPattern">排行</span>');
			diaLog.push('	<div class="btnWrap">');
			diaLog.push('		<button class="again" id="signAgain">重写</button>');
			diaLog.push('		<button class="okSure" id="signSure">确定</button>');
			diaLog.push('		<button class="okSure" id="signCancel">取消</button>');
			diaLog.push('	</div>');
			diaLog.push('</div>');
			diaLog.push('<div id="canvasWrapBg"></div>')
		var diaLogHtml=diaLog.join('');
		$("body").append(diaLogHtml);
		
		if(document.ontouchstart!==null){//pc端
			$('#canvasWrap').css({'width':'50%','height':'92%','left':'25%','top':'10px'});
		}
		jsig.bindClickEvent();
	},
	bindClickEvent:function(){
		var that=this;
		$('#signAgain').bind('click',function(){
			that.reSet();
		})
		$('#signSure').bind('click',function(){
			var _handSign=$("#canvasWrap").attr('signId');
			$('#curImg_'+_handSign).html('');
			$('#imgWrap .line').remove();
			if($("#canvasWrap").hasClass('writeActive')){
				//event.preventDefault();
				html2canvas($('#imgWrap'), {
					allowTaint: true,
					taintTest: false,
					onrendered: function(canvas) {
						canvas.id = "mycanvas";
						canvas.style.background='none';
						//生成base64图片数据
						var dataUrl = canvas.toDataURL();
						var newImg = document.createElement("img");
						newImg.src =  dataUrl;
						document.getElementById('curImg_'+_handSign).appendChild(newImg);
						$('#curImg_'+_handSign).find('img').css({'display':'block','width':'100%','height':'auto'});
						$('#imgWrap').empty();
						$('#canvasWrap,#canvasWrapBg').addClass('hide');
					}
				});
			}else{
				that.getImg();
				$('#canvasWrap,#canvasWrapBg').addClass('hide');
			}
			if(document.ontouchstart!==null){//手机端
				store.set("handsignSrc",$('#curImg_'+_handSign+' img').attr('src'));
			}
		})
		$('#signCancel').bind('click',function(){
			that.reSet();
			$('#imgWrap img').remove();
			$('#canvasWrap,#canvasWrapBg').addClass('hide');
		})
		$('#canvasWrap .tabPattern').bind('click',function(){
			if($(this).html()=='白板'){
				$(this).html('排行');
				$("#canvasWrap").removeClass('writeActive');
				$("#signature").css({'width':'100%','height':'100%'});
			}else{
				$(this).html('白板');
				$('#imgWrap img').remove();
				$("#canvasWrap").addClass('writeActive');
				$('#writeCont').css('height',clientH-350+'px');
				if(document.ontouchstart!==null){//pc端
					$("#signature").css({'width':'150px','height':'150px'});
				}else{
					$("#signature").css({'width':'300px','height':'300px'});
				}
				
			}
			$("#signature canvas").remove();
			$("#signature").jSignature({'UndoButton':true});
			clearTimeout(writeTimer);
		})
	},
	getName:function(){
		var that=this;
		var pubsubprefix = 'jSignature.demo.';
		var export_plugins = that.sigDiv.jSignature('listPlugins','export'),
			name=export_plugins[6];
		return name;
	},
	reSet:function(){
		var that=this;
		var pubsubprefix = 'jSignature.demo.';
		var export_plugins = that.sigDiv.jSignature('listPlugins','export'),
			name=export_plugins[6];
		that.sigDiv.jSignature('reset');
		clearTimeout(writeTimer);
	},
	getImg:function(){
		var _handSign=$("#canvasWrap").attr('signId');
		isWrite=true;
		var that=this;
		var data = that.sigDiv.jSignature('getData', that.jSigName);
		var curImg = new Image();
		curImg.src = 'data:' + data[0] + ',' + data[1];
		
		if($('#canvasWrap').hasClass('writeActive')){
			curImg.width=40;
			curImg.height=40;
			$('#imgWrap').append(curImg);
		}else{
			curImg.width='auto';
			curImg.height=100;
			$('#curImg_'+_handSign).append(curImg);
			$('#curImg_'+_handSign).find('img').css({'display':'block','width':'auto','height':'100px'});
		}
		that.sigDiv.jSignature('reset');
		clearTimeout(writeTimer);
	},
	drawLine:function(){
		var imgWrapH=$('#imgWrap').height();
		for(var i=1;i<parseInt(imgWrapH/50)+1;i++){
			$('#imgWrap').append('<div class="line" style="top:'+i*50+'px;"></div>');
		}
	}
}


//打开窗口 根据业务会再调整
function sigDia(bizFieldId){
	clearTimeout(writeTimer);
	if($('#canvasWrap').size()>0){
		$('#canvasWrap,#canvasWrapBg').removeClass('hide');
	}else{
		jsig.createDialog(bizFieldId);	
	}
	$('.btnWrap,.tabPattern,#signature').show();
	$("#canvasWrap,#canvasWrapBg").removeClass('hide');
	if($("#signature canvas").size()==0){
		jsig.sigDiv = $("#signature").jSignature({'UndoButton':true});
		jsig.jSigName=jsig.getName();
	}else{
		clearTimeout(writeTimer);
	}
}

function saveWriteSignature(bizId) {// 提交业务时自动手写签字 20150310
	var $as=$('[id^="toWrite_"]');
	if($as.size()===0) return; 
	$as.each(function(){
        var $this=$(this),
        	id = $this.attr("id");
    	id = id.slice(id.indexOf('_')+1);// 字段ID
        var signature = $('#curImg_'+id).find('img').attr('src');// 签字图片资源
        if(signature != '' && signature != undefined) {
        	// 传递后台处理
	        $.ajax({
	        	url: CTX + '/platform/signature/signature-stamp!save.action',
	        	type:'post',
	        	data:{'bizId': bizId,'entity.signature':signature, 'bizFieldId': id, 'entity.type' : 1},
	        	success:function(data) {
	        	}
	        });
        }
    });
}




//添加百度编辑器 *zyy*张宇勇
function saveHtmlUeditor(bizId){
	var insertData = $("#iInsertData")[0].innerHTML;
	var $as=$('.formUeditor');
	//var $as=$('[id^="baidu_editor_"]');
	if($as.size()===0) return;
	$as.each(function(){
		var $this=$(this);
        var id = $this.attr("id");
        if( $this[0].childNodes[1]!=undefined){
        	var html = $this[0].childNodes[1].childNodes[0].contentDocument.body.innerHTML;
	        if(insertData.indexOf(id)<0){
	        	$.ajax({
	            	url: CTX + 'platform/htmlEditor/html-editor!save.action',
	            	type:'post',
	            	data:{'bizId': bizId,'html':html,'bizType':id},
	            	success:function(data) {
	            	}
	            })
			}
        }
	});
}

//手机端 添加百度编辑器  *zyy*张宇勇
function showHtmlUeditor(bizId){
	 if(bizId!=null && bizId !=undefined && bizId!=""){
		 $.ajax({
			url: CTX + 'platform/htmlEditor/html-editor!getInnerHTML.action',
			type:'post',
			data:{'bizId': bizId},
			success:function(data) {
				var $as=$('.formUeditor');
				if($as.size()==0){
					return;
				}else if($as.size()==1){
					$as.each(function(){
						var $this=$(this);
				        var id = $this.attr("id");
				        for(var i=0;i<data.length;i++){
				        	var fieldattr = $("#div"+id).attr("fieldattr");
				        	if(fieldattr=="1"){//只读状态
				        		$("#"+id).html(data[i][1]);
				        		$("#"+id).show();
				        	}else{
				        		$this[0].childNodes[1].childNodes[0].contentDocument.body.innerHTML=data[i][1];
				        		
				        	}
				        }
					});
				}else{
					$as.each(function(){
						var $this=$(this);
				        var id = $this.attr("id");
				        for(var i=0;i<data.length;i++){
				        	if(data[i][0]==id){
				        		var fieldattr = $("#div"+id).attr("fieldattr");
					        	if(fieldattr=="1"){//只读状态
					        		$("#"+id).html(data[i][1]);
					        		$("#"+id).show();
					        	}else{
					        		$this[0].childNodes[1].childNodes[0].contentDocument.body.innerHTML=data[i][1];
					        	}
				        	}
				        }
					});
				}
			}
		})
	 } 
}
// 显示签字
function showCur(json){//先将数据加载到页面中,将其他人的签名显示在画布上	
	for(var i in json){
		for(var j=0;j<json[i].length;j++){
			//var imgCreate=new Image();			
			//imgCreate.src = json[i][j];
			var oDiv='<div class="imgSvg" style="background:url('+json[i][j]+') no-repeat;background-size:contain;"></div>';
			$('#curImg_'+i).before(oDiv);
			$('.imgSvg').css({'width':'100px','height':'100px','float':'left'});
			/*if(i.indexOf('handSign')>-1){
				$('#imgs_'+i).find('img').css({'display':'block','width':'auto','height':'50px','float':'left'});
			}else if(i.indexOf('blank')>-1){
				var curIm=$('#imgs_'+i).find('img');
				var firWid=curIm.attr('width');
				var firHei=curIm.attr('height');
				curIm.attr('width','auto');
				curIm.attr('height','50');
				curIm.css({width:'auto',height:'50px','float':'left'});
			}*/

		}
	};
};
// 弹出窗口 显示签字
function showSignuture(bizId){
	$.ajax({
		url: CTX + '/platform/signature/signature-stamp!getSignutures.action',
		type:'post',
		data:{'bizId': bizId, 'entity.type': 1},
		dataType: 'json',
		success:function(data) {
			showCur(data);
		}
	});
}
//判断页面是否调用手签及签章控件，有则执行显示方法？？？？？？？(如何区分是公文页面还是表单页面)
function isShowSignuture(){
	var bizId;
	try{
		bizId= parent.Request.QueryString("pubdjbh");
	}catch(e){
		bizId = getUrlParam("appoid");
	}
	
	if(bizId!= undefined && bizId!= 'undefined'){
		bizId = bizId + '';
		if($('[id^="toWrite_"]').size()>0){//表单流程  
        	showSignuture(bizId);//手写签字显示
    	}
        if($('[id^="stamp_"]').size()>0){//stamp_
        	showStamp(bizId);//图片章显示
        }
	}

}



