var businessId="";
/*
* 门户信息详情
*/
define(['mobilekit','base64'], function () {
	var clickEventType=((document.ontouchstart!==null)?'click':'tap');
    var inface = "api/DoorIndex/",
        messageID = getUrlParam("messageid"),

        _messageDetails = $("#messageDetails"),
        
        init = {
            create: function () {
                init.createDetail();
                init.setMessageRead(messageID);
                init.setTop();
            },
            createDetail: function () {
                sessionStorage.setItem("messageID", messageID);
                var json = init.getMessageDetails(messageID);
                if (json.success == 1) {
                    _messageDetails.find("div.title").text(json.messageTitle)
                    _messageDetails.find("li.department span").text(json.deptName);
                    _messageDetails.find("li.time span").text(json.sendTime);
                    _messageDetails.find("li.people span").text(json.sendUserName);
		    if (isLocal){
	    	            ////@for cordova
	                    var msgHtml = $('<div>'+json.messageHTML+'</div>');
	                    msgHtml.find("img").each(function (e) {
	                        var self = $(this);
	                        var _src = self.attr("src");
	                        if(_src.indexOf('//') < 0){
	                            self.attr("src",baseurl+'..'+_src); //fix path
	                        }
	                    });
	                    msgHtml.find("a").each(function (e) {
	                        var self = $(this);
	                        var _src = self.attr("href");
	                        if(_src.indexOf('//') < 0){
	                            self.attr("href",baseurl+'..'+_src); //fix path
	                        }
	                    });


	                    init.SetText(_messageDetails.find("div.text"), msgHtml.html());
	            }else{
	                init.SetText(_messageDetails.find("div.text"), json.messageHTML);
	            }


                  //  if (json.sendUserCode == appUserId) { //是否可查看阅读人数
                        _messageDetails.find("div.btn-group").css("display", "-webkit-box");
                        _messageDetails.find("a.read span").text(json.readNum);
                        _messageDetails.find("a.unread span").text(json.unReadNum);
                        var focusNum = json.focusNum;
                        var confirmFocus = json.ifFocus;
                        if(focusNum<=0){
        	    			focusNum="关注";
        	    		}
        	    		if(confirmFocus=="1"){
        	    			confirmFocus='<i class="fa fa-heart" aria-hidden="true"></i>';
        	    		}else{
        	    			confirmFocus='<i class="fa fa-heart-o" aria-hidden="true"></i>';
        	    		}
        	    		$("#focusPic").html(confirmFocus);
        	    		$("#focus").html(focusNum);
        	    		businessId = json.messageID;
                   // }
                    var _attachment = _messageDetails.find("ul.attachment");
                    if (json.fileType != "html") { //不是HTML文件,显示下载地址
                        var title = json.messageTitle,
                            _li = $("<li>"),
                            _span = $("<span>").text("正文："),
							_a = '<a href="javascript:;" onclick="gotoDownLoad(\''+json.messageFilePath+'\',\''+messageID+'\')">'+title+'</a>';
                        _li.css("border-top","none")
                        _li.append(_span).append(_a).appendTo(_attachment);
                        _attachment.show();
                    }

                    if (json.filesInfo.length > 0) { //带附件
                        $.each(json.filesInfo, function (index, part) {
                            var _li = $("<li>"),
                                fj = index == 0 ? "附件：" : "　　　",
                                _span = $("<span>").text(fj);
							_a = '<a href="javascript:;" onclick="gotoDownLoad(\''+part.fileId+'\',\''+messageID+'\')">'+part.fileName+'</a>';
                            
                            if (index == 0) _li.addClass("cborder");
                            _li.append(_span).append(_a).appendTo(_attachment);
                        });
                        _attachment.show()
                    }

                    init.setCache(json);

                } else {
                    _messageDetails.html("信息加载失败，请点击重试!")
                }
            },
            /*
            * 获取信息详情
            */
            getMessageDetails: function (messageID) {
                var url = inface + "GetMessageDetails";
                var data = GetDataByUrl_Post(url, messageID);
                var json = JSON.parse(JSON.stringify(data));
                return json;
            },
            /*
            * 设置缓存
            */
            setCache: function (json) {
                sessionStorage.setItem("messageTitle", json.messageTitle);
            },
            /*
            * 设置已阅或更新阅读次数
            */
            setMessageRead: function (messageID) {
                var url = inface + "SetMessageRead";
                var data = GetDataByUrl_Post(url, messageID);
                var json = JSON.parse(JSON.stringify(data));
            },
            /*
            * 设置置顶功能
            */
            setTop: function () {
                // 获取置顶对象
                var _toTop = $("#toTop");
                // 置顶对象点击事件
                _toTop.on("tap", function () {
                    var timer = setInterval(function () {
                        window.scrollBy(0, -50);
                        if (document.body.scrollTop == 0) {
                            clearInterval(timer);
                        };
                    }, 2);
                })
                // 窗口滚动检测
                window.onscroll = function () {
                    _toTop[0].style.display = (document.body.scrollTop >= 40) ? "block" : "none";
                }
            },
            /*
            * 获取文件扩展名
            * @name 文件名
            */
            getExt: function (name) {
                var t = name.lastIndexOf(".");
                var k = name.substring(t, t.length);
                return k;
            },
            /*
            * 正文内容处理
            */
            SetText: function (opt, meaasgeHTML) {
                opt.hide();
                meaasgeHTML = meaasgeHTML.replace(/<IMG/, "<IMG style=\"max-width:100%;\"");
                meaasgeHTML = meaasgeHTML.replace(/<TABLE/, "<TABLE style=\"width:100%;\"");
                opt.html(meaasgeHTML) 
                opt.show()
            },


        }

    //初始化加载页面数据
    $(function () {
        init.create();
        initOverReadButton();
    })
	
	function initOverReadButton() {
    	var haveButton = getUrlParam("haveButton");
    	if (null != haveButton && haveButton != undefined){
    		var strappG_Id = getUrlParam("strappG_Id");
    		var str = '<a class="btn overread" href="javascript:void(0);"><span>阅办完成</span></a>';
    		var $btn = $(str);
    		$(".btn-group").append(str);
    		WbindOnclick(strappG_Id);
    	}
    }
    
    function WbindOnclick(strappG_Id) {
    	$(".overread").each(function() {
    		var _a=$(this);
        	_a.unbind(clickEventType);
        	_a.bind(clickEventType, function() {
        		var params = {
                    AppG_Id: strappG_Id
                };
                var saveJsonStr = JSON.stringify(params);
                var data = GetDataByUrl_Post("api/WorkFlow/WaitReadBanjie", saveJsonStr);
                if (data && data.success == 1) {
                    toast("阅办完成。");
                    if (store.get("newWebView")=="1") {//如果是1关闭当前WebView
    					if(store.get("browser")=="1"){
    						goHome(-1);
    					} else {
    						goHome();
    					}
    		    	} else{
    		    		window.location.href = "../workFlow/waitRead.html";
    		    	}
                } else {
                    toast(data.mes);//提示
                }
            });
        });
    }


});

/**
 * 关注
 */
function focusInfo(){
	var title = $("#messageDetails").find("div.title").text();
	var typeCode = "4";
	var confirmFocus = "";
	var focusNum = $("#focus").html();
	var focusNumNew = "";
	if(focusNum=="关注"){
		focusNum="0";
	}
	var data = '{"businessId":"' + businessId + '","typeCode":"' + typeCode + '","title":"' + title + '"}';
    var result = GetDataByUrl_Post("api/Work/checkFocus",data);
    var json = JSON.stringify(result);
    json = JSON.parse(json);
    if(json.success=="1"){
    	focusNumNew = Number(focusNum)-1;
    	if(focusNumNew<=0){
    		focusNumNew = "关注";
    	}
    	confirmFocus='<i class="fa fa-heart-o" aria-hidden="true"></i>';
    }else{
    	focusNumNew = Number(focusNum)+1;
    	confirmFocus='<i class="fa fa-heart" aria-hidden="true"></i>';
    }
    $("#focusPic").html(confirmFocus);
    $("#focus").html(focusNumNew);
}
